#include "camera.h"

class MbDOFPerspectiveCamera : public Camera {
public:
  MbDOFPerspectiveCamera(const Transform *world2cam, int nTransforms,
			 Float hither, Float yon, 
			 Float shutterOpen, float shutterClose,
			 Float fstop, 
			 Float focalLen, 
			 Float focalDist, 
			 RtToken mode, 
			 Float fov,
			 Film *film);
	~MbDOFPerspectiveCamera() {};
	bool GenerateRay(Float sample[5], Ray &ray) const;
	void AdjustAutomatically(const Scene *scene);
private:
	Transform WorldToCamera0, WorldToCamera1;
	Float ShutterStart, ShutterEnd;
	Float FStop, FocalLength, FocalDistance;
	RtToken Mode;

	void GenerateRay(Float apertureX, Float apertureY, Point pointOnRay, Float time, Ray &ray) const;
	void EstimateDistanceAndExposure (const Scene *scene, Float timelimit, Float windowFrac[4],
									  int probeRes[3], Float &exposure, Float *zsamples);
};
